org.apache.commons.math3.optimization.univariate

## Class UnivariateMultiStartOptimizer<FUNC extends UnivariateFunction>

- java.lang.Object
- - org.apache.commons.math3.optimization.univariate.UnivariateMultiStartOptimizer<FUNC>

Type Parameters:
  `FUNC` - Type of the objective function to be optimized.

All Implemented Interfaces:
  BaseOptimizer<UnivariatePointValuePair>, BaseUnivariateOptimizer<FUNC>

Deprecated.
As of 3.1 (to be removed in 4.0).

    @Deprecated
    public class UnivariateMultiStartOptimizer<FUNC extends UnivariateFunction>
    extends java.lang.Object
    implements BaseUnivariateOptimizer<FUNC>

Special implementation of the `UnivariateOptimizer` interface adding multi-start features to an existing optimizer. This class wraps a classical optimizer to use it several times in turn with different starting points in order to avoid being trapped into a local extremum when looking for a global one.

Since:
  3.0
Version:
  $Id: UnivariateMultiStartOptimizer.java 1422230 2012-12-15 12:11:13Z erans $

### Field Summary

Fields
`private RandomGenerator` `generator` Deprecated. Random generator for multi-start.
`private int` `maxEvaluations` Deprecated. Maximal number of evaluations allowed.
`private UnivariatePointValuePair[]` `optima` Deprecated. Found optima.
`private BaseUnivariateOptimizer<FUNC>` `optimizer` Deprecated. Underlying classical optimizer.
`private int` `starts` Deprecated. Number of starts to go.
`private int` `totalEvaluations` Deprecated. Number of evaluations already performed for all starts.

### Constructor Summary

Constructors
Constructor and Description
`UnivariateMultiStartOptimizer(BaseUnivariateOptimizer<FUNC> optimizer, int starts, RandomGenerator generator)` Deprecated. Create a multi-start optimizer from a single-start optimizer.

### Method Summary

Methods
`ConvergenceChecker<UnivariatePointValuePair>` `getConvergenceChecker()` Deprecated. Get the convergence checker.
`int` `getEvaluations()` Deprecated. Get the number of evaluations of the objective function.
`int` `getMaxEvaluations()` Deprecated. Get the maximal number of function evaluations.
`UnivariatePointValuePair[]` `getOptima()` Deprecated. Get all the optima found during the last call to `optimize`.
`UnivariatePointValuePair` `optimize(int maxEval, FUNC f, GoalType goal, double min, double max)` Deprecated. Find an optimum in the given interval.
`UnivariatePointValuePair` `optimize(int maxEval, FUNC f, GoalType goal, double min, double max, double startValue)` Deprecated. Find an optimum in the given interval, start at startValue.
`private void` `sortPairs(GoalType goal)` Deprecated. Sort the optima from best to worst, followed by `null` elements.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### optimizer

    private final BaseUnivariateOptimizer<FUNC extends UnivariateFunction> optimizer

Deprecated.
Underlying classical optimizer.

#### maxEvaluations

    private int maxEvaluations

Deprecated.
Maximal number of evaluations allowed.

#### totalEvaluations

    private int totalEvaluations

Deprecated.
Number of evaluations already performed for all starts.

#### starts

    private int starts

Deprecated.
Number of starts to go.

#### generator

    private RandomGenerator generator

Deprecated.
Random generator for multi-start.

#### optima

    private UnivariatePointValuePair[] optima

Deprecated.
Found optima.

### Constructor Detail

#### UnivariateMultiStartOptimizer

    public UnivariateMultiStartOptimizer(BaseUnivariateOptimizer<FUNC> optimizer,
                                 int starts,
                                 RandomGenerator generator)

Deprecated.
Create a multi-start optimizer from a single-start optimizer.

Parameters:
  `optimizer` - Single-start optimizer to wrap.
  `starts` - Number of starts to perform. If `starts == 1`, the `optimize` methods will return the same solution as `optimizer` would.
  `generator` - Random generator to use for restarts.
Throws:
  `NullArgumentException` - if `optimizer` or `generator` is `null`.
  `NotStrictlyPositiveException` - if `starts < 1`.

### Method Detail

#### getConvergenceChecker

    public ConvergenceChecker<UnivariatePointValuePair> getConvergenceChecker()

Deprecated.
Get the convergence checker.

Specified by:
  `getConvergenceChecker` in interface `BaseOptimizer<UnivariatePointValuePair>`
Returns:
  the object used to check for convergence.

#### getMaxEvaluations

    public int getMaxEvaluations()

Deprecated.
Get the maximal number of function evaluations.

Specified by:
  `getMaxEvaluations` in interface `BaseOptimizer<UnivariatePointValuePair>`
Returns:
  the maximal number of function evaluations.

#### getEvaluations

    public int getEvaluations()

Deprecated.
Get the number of evaluations of the objective function. The number of evaluations corresponds to the last call to the `optimize` method. It is 0 if the method has not been called yet.

Specified by:
  `getEvaluations` in interface `BaseOptimizer<UnivariatePointValuePair>`
Returns:
  the number of evaluations of the objective function.

#### getOptima

    public UnivariatePointValuePair[] getOptima()

Deprecated.
Get all the optima found during the last call to `optimize`. The optimizer stores all the optima found during a set of restarts. The `optimize` method returns the best point only. This method returns all the points found at the end of each starts, including the best one already returned by the `optimize` method.
The returned array as one element for each start as specified in the constructor. It is ordered with the results from the runs that did converge first, sorted from best to worst objective value (i.e in ascending order if minimizing and in descending order if maximizing), followed by `null` elements corresponding to the runs that did not converge. This means all elements will be `null` if the `optimize` method did throw an exception. This also means that if the first element is not `null`, it is the best point found across all starts.

Returns:
  an array containing the optima.
Throws:
  `MathIllegalStateException` - if `optimize` has not been called.

#### optimize

    public UnivariatePointValuePair optimize(int maxEval,
                                    FUNC f,
                                    GoalType goal,
                                    double min,
                                    double max)

Deprecated.
Find an optimum in the given interval. An optimizer may require that the interval brackets a single optimum.

Specified by:
  `optimize` in interface `BaseUnivariateOptimizer<FUNC extends UnivariateFunction>`
Parameters:
  `maxEval` - Maximum number of function evaluations.
  `f` - Function to optimize.
  `goal` - Type of optimization goal: either `GoalType.MAXIMIZE` or `GoalType.MINIMIZE`.
  `min` - Lower bound for the interval.
  `max` - Upper bound for the interval.
Returns:
  a (point, value) pair where the function is optimum.

#### optimize

    public UnivariatePointValuePair optimize(int maxEval,
                                    FUNC f,
                                    GoalType goal,
                                    double min,
                                    double max,
                                    double startValue)

Deprecated.
Find an optimum in the given interval, start at startValue. An optimizer may require that the interval brackets a single optimum.

Specified by:
  `optimize` in interface `BaseUnivariateOptimizer<FUNC extends UnivariateFunction>`
Parameters:
  `maxEval` - Maximum number of function evaluations.
  `f` - Function to optimize.
  `goal` - Type of optimization goal: either `GoalType.MAXIMIZE` or `GoalType.MINIMIZE`.
  `min` - Lower bound for the interval.
  `max` - Upper bound for the interval.
  `startValue` - Start value to use.
Returns:
  a (point, value) pair where the function is optimum.

#### sortPairs

    private void sortPairs(GoalType goal)

Deprecated.
Sort the optima from best to worst, followed by `null` elements.

Parameters:
  `goal` - Goal type.